import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Steperjjservice} from './Steperjj.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Steperjjcardvariable } from './Steperjj_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Steperjj',
  templateUrl: './Steperjj.component.html',
  styleUrls: ['./Steperjj.component.scss']
})
export class SteperjjComponent implements OnInit {
  cardButton = Steperjjcardvariable.cardButton;
  cardmodeldata = Steperjjcardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Steperjjcardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Steperjj_formCode'
tableName = 'Steperjj';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Steperjjservice,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
names : [null],

numbers0 : [null,[Validators.required]],

numbers02 : [null,[Validators.required]],



 


 









  }); // component_button200
 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Steperjj_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 











  }










 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;






//calculated field start
	
 
	   this.calculateaddnumbers0= row.numbers0;
	  

 
	   this.calculateaddnumbers02= row.numbers02;
	  

//calculated field end




    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;






//calculated field start
	
 
this.rowSelected.numbers0= this.calculateaddnumbers0;
	 

 
this.rowSelected.numbers02= this.calculateaddnumbers02;
	 

this.onInputChangecalculateadd ();
 //calculated field end



    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);










      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;






//calculated field start
	
 
this.entryForm.value.numbers0  = this.calculateaddnumbers0 ;
	  

 
this.entryForm.value.numbers02  = this.calculateaddnumbers02 ;
	  

//calculated field end



  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);










      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;





  //calculated field start

  
 
  this.calculateaddnumbers0  = '';
 

 
  this.calculateaddnumbers02  = '';
 



  this.calculateaddtotal = '';

  //calculated field end

 this.getdatagrid_fieldData();


  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 






 // calculated field code start 

 
 calculateaddnumbers0; 
  

 
 calculateaddnumbers02; 
  

  calculateaddtotal ; 
 calculateaddcalculateOperators = "Addition"
onInputChangecalculateadd() {
const lastObj = 0
const lastObjstring = ''
	
 

    const numbers0= this.calculateaddnumbers0|| '';

	const numbers0Value = parseFloat(this.calculateaddnumbers0) || 0;

	  

 

    const numbers02= this.calculateaddnumbers02|| '';

	const numbers02Value = parseFloat(this.calculateaddnumbers02) || 0;

	  

if (this.calculateaddcalculateOperators =="Addition") {
 this.calculateaddtotal = (   
	
 
		 numbers0Value +
	 

 
		 numbers02Value +
	 
 lastObj).toString();
}
if (this.calculateaddcalculateOperators == "Subtraction") {
	 this.calculateaddtotal = (   

 
 numbers0Value   -
	 

 
 numbers02Value   -
	 

	lastObj).toString();
}
if (this.calculateaddcalculateOperators =="Multiplication") {
  this.calculateaddtotal = (

	
 
	numbers0Value *
		 

 
	numbers02Value *
		 

lastObj).toString();
}
if (this.calculateaddcalculateOperators =="Division") {
 
	this.calculateaddtotal = ( 

 
numbers0Value   /
	 

 
numbers02Value   /
	 

lastObj).toString();

}
if (this.calculateaddcalculateOperators =="Concatination") {
 this.calculateaddtotal =  

 
numbers0+ ' '+
	 

 
numbers02+ ' '+
	 
 lastObjstring 
}
}

//datagrid datagrid_field  filed start    
productdatagrid_field;     
 rowsdatagrid_field :any[];
         getHeadersdatagrid_field () {          
			 this.rowsdatagrid_field = this.productdatagrid_field;         
  let headers: string[] = [];
          if(this.rowsdatagrid_field ) {             
this.rowsdatagrid_field.forEach((value) => {         
      Object.keys(value).forEach((key) => {
                if(!headers.find((header) => header == key)){
                  headers.push(key)             
    }         
              })                 
     })         
}
         
 return headers;      
   } 
 //datagrid datagrid_field filed end 
					    
getdatagrid_fieldData() {
    this.mainService.getdatagrid_fieldAll().subscribe((data) => {
      console.log(data);      this.productdatagrid_field  = data; 
    });
}

// updateaction
}









